var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
import React, { forwardRef, useRef, useEffect } from "react";
import { ValueSelector } from "react-querybuilder";
const BootstrapDragHandle = forwardRef(({ className, title }, dragRef) => /* @__PURE__ */ React.createElement("span", {
  ref: dragRef,
  className,
  title
}, /* @__PURE__ */ React.createElement("i", {
  className: "bi bi-grip-vertical"
})));
BootstrapDragHandle.displayName = "BootstrapDragHandle";
const BootstrapNotToggle = ({
  className,
  handleOnChange,
  title,
  label,
  checked,
  disabled
}) => {
  const id = useRef(`notToggle-${Math.random()}`);
  return /* @__PURE__ */ React.createElement("div", {
    className: `form-check-inline form-switch ${className}`
  }, /* @__PURE__ */ React.createElement("input", {
    id: id.current,
    className: "form-check-input",
    type: "checkbox",
    onChange: (e) => handleOnChange(e.target.checked),
    checked: !!checked,
    disabled
  }), /* @__PURE__ */ React.createElement("label", {
    title,
    htmlFor: id.current,
    className: "form-check-label"
  }, label));
};
BootstrapNotToggle.displayName = "BootstrapNotToggle";
const BootstrapValueEditor = (_a) => {
  var _b = _a, {
    fieldData,
    operator,
    value,
    handleOnChange,
    title,
    className,
    type,
    inputType,
    values,
    disabled
  } = _b, props = __objRest(_b, [
    "fieldData",
    "operator",
    "value",
    "handleOnChange",
    "title",
    "className",
    "type",
    "inputType",
    "values",
    "disabled"
  ]);
  var _a2;
  useEffect(() => {
    if (inputType === "number" && !["between", "notBetween", "in", "notIn"].includes(operator) && typeof value === "string" && value.includes(",")) {
      handleOnChange("");
    }
  }, [inputType, operator, value, handleOnChange]);
  if (operator === "null" || operator === "notNull") {
    return null;
  }
  const placeHolderText = (_a2 = fieldData == null ? void 0 : fieldData.placeholder) != null ? _a2 : "";
  const inputTypeCoerced = ["between", "notBetween", "in", "notIn"].includes(operator) ? "text" : inputType || "text";
  switch (type) {
    case "select":
    case "multiselect":
      return /* @__PURE__ */ React.createElement(ValueSelector, __spreadProps(__spreadValues({}, props), {
        className: `${className} form-select form-select-sm`,
        title,
        handleOnChange,
        value,
        disabled,
        multiple: type === "multiselect",
        options: values
      }));
    case "textarea":
      return /* @__PURE__ */ React.createElement("textarea", {
        value,
        title,
        className,
        disabled,
        placeholder: placeHolderText,
        onChange: (e) => handleOnChange(e.target.value)
      });
    case "switch":
      return /* @__PURE__ */ React.createElement("span", {
        className: `custom-control custom-switch ${className}`
      }, /* @__PURE__ */ React.createElement("input", {
        type: "checkbox",
        className: `form-check-input custom-control-input`,
        title,
        disabled,
        onChange: (e) => handleOnChange(e.target.checked),
        checked: !!value
      }));
    case "checkbox":
      return /* @__PURE__ */ React.createElement("input", {
        type: "checkbox",
        className: `form-check-input ${className}`,
        title,
        disabled,
        onChange: (e) => handleOnChange(e.target.checked),
        checked: !!value
      });
    case "radio":
      return /* @__PURE__ */ React.createElement("span", {
        title
      }, values.map((v) => /* @__PURE__ */ React.createElement("div", {
        key: v.name,
        className: "form-check form-check-inline"
      }, /* @__PURE__ */ React.createElement("input", {
        className: "form-check-input",
        type: "radio",
        id: v.name,
        value: v.name,
        checked: value === v.name,
        disabled,
        onChange: (e) => handleOnChange(e.target.value)
      }), /* @__PURE__ */ React.createElement("label", {
        className: "form-check-label",
        htmlFor: v.name
      }, v.label))));
  }
  return /* @__PURE__ */ React.createElement("input", {
    type: inputTypeCoerced,
    value,
    title,
    className,
    disabled,
    placeholder: placeHolderText,
    onChange: (e) => handleOnChange(e.target.value)
  });
};
BootstrapValueEditor.displayName = "BootstrapValueEditor";
const bootstrapControlElements = {
  dragHandle: BootstrapDragHandle,
  notToggle: BootstrapNotToggle,
  valueEditor: BootstrapValueEditor
};
const bootstrapControlClassnames = {
  addGroup: "btn btn-secondary btn-sm",
  addRule: "btn btn-primary btn-sm",
  cloneGroup: "btn btn-secondary btn-sm",
  cloneRule: "btn btn-secondary btn-sm",
  lockGroup: "btn btn-secondary btn-sm",
  lockRule: "btn btn-secondary btn-sm",
  removeGroup: "btn btn-danger btn-sm",
  removeRule: "btn btn-danger btn-sm",
  combinators: "form-select form-select-sm",
  fields: "form-select form-select-sm",
  operators: "form-select form-select-sm",
  value: "form-control form-control-sm",
  valueSource: "form-select form-select-sm"
};
export { BootstrapDragHandle, BootstrapNotToggle, BootstrapValueEditor, bootstrapControlClassnames, bootstrapControlElements };
//# sourceMappingURL=index.es.js.map
